<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\Sm00001002PropostaHistoricoService;
use SM\Traits\TResponse;

class Sm00001002PropostaHistoricoController extends SMCrud
{

    use TResponse;

    protected $Sm00001002PropostaHistoricoService;

    public function __construct($crudService, $environment, Sm00001002PropostaHistoricoService $Sm00001002PropostaHistoricoService)
    {
            parent::__construct($crudService, $environment);
            $this->Sm00001002PropostaHistoricoService = $Sm00001002PropostaHistoricoService;
    }

    public function getHistoricoProposta()
    {
        try {
            $data = $this->Sm00001002PropostaHistoricoService->getHistoricoProposta();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
