/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MODP                                                     */
/* Tabela : MODPGTO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 28/01/2004 - Raphael Freitas Pinheiro                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MODP
BEFORE INSERT OR UPDATE OR DELETE
ON MODPGTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMPGT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMODPGTO,0) <> NVL(:NEW.CDMODPGTO,0)) OR
         (NVL(:OLD.DSMODPGTO,0) <> NVL(:NEW.DSMODPGTO,0)) OR
         (NVL(:OLD.CDFORMPGTO,0) <> NVL(:NEW.CDFORMPGTO,0)) OR
         (NVL(:OLD.IDTPFORPGTOMOD,0) <> NVL(:NEW.IDTPFORPGTOMOD,0)) OR
         (NVL(:OLD.NRDIAPGFIXMOD,0) <> NVL(:NEW.NRDIAPGFIXMOD,0)) OR
         (NVL(:OLD.NRPARCPGTOMOD,0) <> NVL(:NEW.NRPARCPGTOMOD,0)) OR
         (NVL(:OLD.IDUTDIAPAGMOD,0) <> NVL(:NEW.IDUTDIAPAGMOD,0)) OR
         (NVL(:OLD.VRFATAJUPARC,0) <> NVL(:NEW.VRFATAJUPARC,0)) OR
         (NVL(:OLD.CDTIPORECE,0) <> NVL(:NEW.CDTIPORECE,0)) OR
         (NVL(:OLD.VRPEDESMODPG,0) <> NVL(:NEW.VRPEDESMODPG,0)) OR
         (NVL(:OLD.IDLANCPEDMOD,0) <> NVL(:NEW.IDLANCPEDMOD,0)) THEN
         :NEW.DTULTATUMPGT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MODPGTO', '', 'CDMODPGTO='||:OLD.CDMODPGTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MODPGTO MODIFY DTULTATUMPGT DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MODP','5.30.000'); END;
/
