/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_HABILIDADE                                               */
/* Tabela : HABILIDADE                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 07/11/2007 - Welbert G. Moitinha                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PROCFABRICA
BEFORE INSERT OR UPDATE OR DELETE
ON PROCFABRICA FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPFAB := SYSDATE;
   END IF;

   IF UPDATING THEN
      IF (NVL(:OLD.CDPROCFABRIC,0) <> NVL(:NEW.CDPROCFABRIC,0)) OR
         (NVL(:OLD.IDPROFABPADR,0) <> NVL(:NEW.IDPROFABPADR,0)) OR
         (NVL(:OLD.QTPADPROCFAB,0) <> NVL(:NEW.QTPADPROCFAB,0)) THEN
         :NEW.DTULTATUPFAB := SYSDATE;
      END IF;
   END IF;

   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PROCFABRICA', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDPRODUTO='||:OLD.CDPRODUTO||';CDPROCFABRIC='||:OLD.CDPROCFABRIC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PROCFABRICA MODIFY DTULTATUPFAB DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PROCFABRICA','4.00.000'); END;
/
