IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'VALOR_SERVICO_MERENDA' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION VALOR_SERVICO_MERENDA
GO

CREATE FUNCTION VALOR_SERVICO_MERENDA
(@P_CDFILCENTPME VARCHAR(4),
 @P_CDTIPOCARD VARCHAR(10),
 @P_CDFILIAL   VARCHAR(4),
 @P_CDSERVFILI VARCHAR(5),
 @P_CDCLIENTE  VARCHAR(21),
 @P_DATAAPURAC DATETIME)
RETURNS DOUBLE PRECISION 
AS
BEGIN
   DECLARE @V_VRSERVICO DOUBLE PRECISION;
   
   SELECT @V_VRSERVICO = MAX(H.VRSERVICO)
     FROM HISTVRSERVPME H
          /*Pega a maior data de vigncia menor ou igual  data de apurao*/
          INNER JOIN (SELECT CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                             CDSERVFILI, CDCLIENTE, MAX(DTVIGENCIA) DTVIGENCIA
                        FROM HISTVRSERVPME
                       WHERE CDFILCENTPME = @P_CDFILCENTPME AND
                             CDTIPOCARD   = @P_CDTIPOCARD   AND
                             CDFILIAL     = @P_CDFILIAL     AND
                             CDSERVFILI   = @P_CDSERVFILI   AND
                             CDCLIENTE    = @P_CDCLIENTE    AND
                             DTVIGENCIA <= CONVERT(DATE,@P_DATAAPURAC)
                       GROUP BY CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                             CDSERVFILI, CDCLIENTE
                     ) MV ON H.CDFILCENTPME = MV.CDFILCENTPME AND
                             H.CDTIPOCARD = MV.CDTIPOCARD AND
                             H.CDFILIAL = MV.CDFILIAL AND
                             H.CDSERVFILI = MV.CDSERVFILI AND
                             H.CDCLIENTE = MV.CDCLIENTE AND
                             H.DTVIGENCIA = MV.DTVIGENCIA
         /*Pega a maior data de atualizao (ltima alterao feito no valor) para a data de vigncia escolhida*/
         INNER JOIN (SELECT CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                            CDSERVFILI, CDCLIENTE, DTVIGENCIA, MAX(DTATUALIZACAO) DTATUALIZACAO
                        FROM HISTVRSERVPME
                       WHERE CDFILCENTPME = @P_CDFILCENTPME AND
                             CDTIPOCARD   = @P_CDTIPOCARD   AND
                             CDFILIAL     = @P_CDFILIAL     AND
                             CDSERVFILI   = @P_CDSERVFILI   AND
                             CDCLIENTE    = @P_CDCLIENTE    AND
                             DTVIGENCIA <= CONVERT(DATE,@P_DATAAPURAC)
                       GROUP BY CDFILCENTPME, CDTIPOCARD, CDFILIAL,
                             CDSERVFILI, CDCLIENTE, DTVIGENCIA
                     ) MA ON H.CDFILCENTPME = MA.CDFILCENTPME AND
                             H.CDTIPOCARD = MA.CDTIPOCARD AND
                             H.CDFILIAL = MA.CDFILIAL AND
                             H.CDSERVFILI = MA.CDSERVFILI AND
                             H.CDCLIENTE = MA.CDCLIENTE AND
                             H.DTVIGENCIA = MA.DTVIGENCIA AND
                             H.DTATUALIZACAO = MA.DTATUALIZACAO
    WHERE H.CDFILCENTPME = @P_CDFILCENTPME AND
          H.CDTIPOCARD   = @P_CDTIPOCARD   AND
          H.CDFILIAL     = @P_CDFILIAL     AND
          H.CDSERVFILI   = @P_CDSERVFILI   AND
          H.CDCLIENTE    = @P_CDCLIENTE    AND          
          H.DTVIGENCIA  <= CONVERT(DATE,@P_DATAAPURAC);
   
   RETURN(ISNULL(@V_VRSERVICO, 0));
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'VALOR_SERVICO_MERENDA','5.85.000';
GO